![WP Document Revisions header logo](https://user-images.githubusercontent.com/282759/120903696-a46aaf00-c615-11eb-947e-60554e9fff95.png)

# WP Document Revisions

[![CI](https://github.com/wp-document-revisions/wp-document-revisions/actions/workflows/ci.yml/badge.svg)](https://github.com/wp-document-revisions/wp-document-revisions/actions/workflows/ci.yml) [![Crowdin](https://d322cqt584bo4o.cloudfront.net/wordpress-document-revisions/localized.svg)](https://crowdin.com/project/wordpress-document-revisions) [![PRs Welcome](https://img.shields.io/badge/PRs-welcome-brightgreen.svg?style=flat-square)](http://makeapullrequest.com) [![Coverage Status](https://codecov.io/gh/wp-document-revisions/wp-document-revisions/branch/master/graphs/badge.svg?branch=master)](https://codecov.io/github/wp-document-revisions/wp-document-revisions?branch=master)

A document management and version control plugin for WordPress that allows teams of any size to collaboratively edit files and manage their workflow.

## Description

[WP Document Revisions](https://wordpress.org/plugins/wp-document-revisions/) is a [document management](https://en.wikipedia.org/wiki/Document_management_system) and [version control](http://en.wikipedia.org/wiki/Revision_control) plugin. Built for time-sensitive and mission-critical projects, teams can collaboratively edit files of any format -- text documents, spreadsheets, images, sheet music... anything -- all the while, seamlessly tracking the document's progress as it moves through your organization's existing workflow.

### WP Document Revisions is three things

1. A **document management system** (DMS), to track, store, and organize files of any format
2. A **collaboration tool** to empower teams to collaboratively draft, edit, and refine documents
3. A **file hosting solution** to publish and securely deliver files to a team, to clients, or to the public

See [**the full list of features**](./features.md) for more information.

## Documentation

See [the full documentation](https://wp-document-revisions.github.io/wp-document-revisions)

### Learn

* [Features and Overview](./features.md)
* [Screenshots](./screenshots.md)
* [Installation](./installation.md)
* [Frequently Asked Questions](./frequently-asked-questions.md)
* [Links](./links.md)
* [Where to get Support or Report an Issue](./SUPPORT.md)
* [Translations](./translations.md)
* [Plugin Actions](./actions.md)
* [Plugin Filters](./filters.md)
* [Plugin Shortcodes and Widget](./shortcodes.md)
* [Useful Plugins and Tools](./useful-plugins-and-tools.md)

### Get Involved

* [How to Contribute](./CONTRIBUTING.md)
* [Join the List Serve](https://groups.google.com/forum/#!forum/wp-document-revisions)
